extends Camera3D

@export var materials : Array[ShaderMaterial]

var undistorted = true

func _ready():
	var view_size = get_viewport().size
	_update_projection(view_size)


func _on_view_size_changed():
	if get_viewport():
		_update_projection(get_viewport().size)


func _update_projection(view_size):
	var aspect = view_size.x / float(view_size.y)
	var fovy = rad_to_deg(2 * atan(tan(deg_to_rad(fov) * 0.5) * aspect))
	var _projection : Projection = Projection.create_perspective(fovy, aspect, near, far, keep_aspect == KEEP_HEIGHT)
	for material in materials:
		material.set_shader_parameter("projection", _projection)
		material.set_shader_parameter("viewport_size", view_size)


func _on_hud_undistort_toggled(enabled):
	undistorted = enabled
	if !undistorted:
		_update_fov(get_viewport().size)


func _update_fov(view_size):
	var aspect = view_size.x / float(view_size.y)
	fov = rad_to_deg(2 * atan(deg_to_rad(170) * 0.5) * aspect)
